#include "Vektor.hpp"
#include "sstream"

// Konstruktor
Vektor::Vektor()
{
  x = 0;
  y = 0;
}
Vektor::Vektor(double x, double y)
{
  this->x = x;
  this->y = y;
}


// nicht-statische Memberfunktionen
void Vektor::addieren(const Vektor &v2)
{
  x += v2.x;
  y += v2.y;
}
void Vektor::subtrahieren(const Vektor &v2)
{
  x -= v2.x;
  y -= v2.y;
}

string Vektor::alsString()
{
 stringstream stream;
 stream << "(" << x << "," << y << ")";
 string s;
 stream >> s;
 return s;
}


void Vektor::set_x(double x)
{
  this->x = x;
}
void Vektor::set_y(double y)
{
  this->y = y;
}

double Vektor::get_x()
{
  return x;
}
double Vektor::get_y()
{
  return y;
}


// statische Membrfunktionen
Vektor Vektor::addieren(const Vektor &v1, const Vektor &v2)
{
   // Neues Vektor-Objekt als Summe der beiden Parameter erzeugen
   Vektor tmp(v1.x + v2.x, v1.y + v2.y);
  
   // Vektor-Objekt als Kopie zurckgeben (nie als Referenz, da das 
   // lokale Objekt tmp ja am Ende der Memberfunktion
   // addieren() aufgelst wird.
   return tmp;
}
Vektor Vektor::subtrahieren(const Vektor &v1, const Vektor &v2)
{
   // Neues Vektor-Objekt als Differenz der beiden Parameter erzeugen
   Vektor tmp(v1.x - v2.x, v1.y - v2.y);
  
   // Vektor-Objekt als Kopie zurckgeben (nie als Referenz, da das 
   // lokale Objekt tmp ja am Ende der Memberfunktion
   // addieren() aufgelst wird.
   return tmp;
}
